<app-navbar></app-navbar>
<div layout="row" layout-align="space-between center" flex class="layout-align-space-between-center layout-row flex">
    <mat-form-field>
        <input matInput (keyup)="applyFilter($event.target.value)" placeholder="Search Users">
    </mat-form-field>&nbsp;&nbsp;

    <button class="btn-secondary" mat-mini-fab matTooltip="Add a User">
        <mat-icon routerLink="/add-user" aria-label="add user">add</mat-icon>
    </button>
</div>

<div class="basic-container mat-elevation-z8">
    <table mat-table [dataSource]="dataSource" matSort matSortActive="id" matSortDirection="desc" matSortDisableClear>

        <!-- Id Column -->
        <!--<ng-container matColumnDef="id" >
            <th mat-header-cell *matHeaderCellDef mat-sort-header disableClear>ID</th>
            <td mat-cell *matCellDef="let user">{{ user.id }}</td>
        </ng-container>-->

        <!-- UserName Column -->
        <ng-container matColumnDef="userName">
            <th mat-header-cell *matHeaderCellDef mat-sort-header>User Name</th>
            <td mat-cell *matCellDef="let user">{{ user.userName }}</td>
        </ng-container>

        <!-- Name Column -->
        <ng-container matColumnDef="fullName">
            <th mat-header-cell *matHeaderCellDef mat-sort-header>Name</th>
            <td mat-cell *matCellDef="let user">{{ getFullName(user) }}</td>
        </ng-container>

        <ng-container matColumnDef="contact">
            <th mat-header-cell *matHeaderCellDef mat-sort-header>Contact</th>
            <td mat-cell *matCellDef="let user">{{ user.contactNumber }}</td>
        </ng-container>

        <ng-container matColumnDef="regCode">
            <th mat-header-cell *matHeaderCellDef mat-sort-header>Reg Code</th>
            <td mat-cell *matCellDef="let user">{{ user.regCode }}</td>
        </ng-container>

        <!-- Work Type Column -->
        <ng-container matColumnDef="role">
            <th mat-header-cell *matHeaderCellDef mat-sort-header>Role</th>
            <td mat-cell *matCellDef="let user">{{ user.role.roleName }}</td>
        </ng-container>

        <!-- Action Column -->
        <ng-container matColumnDef="action">
            <th mat-header-cell *matHeaderCellDef mat-sort-header>Action</th>
            <td mat-cell *matCellDef="let user">
                <button mat-icon-button color="accent" matTooltip="edit a user">
                    <mat-icon (click)="editUser(user.id)" aria-label="edit user">edit</mat-icon>
                </button>
                <button mat-icon-button color="warn" matTooltip="delete a user">
                    <mat-icon (click)="deleteUser(user)" aria-label="delete contact">delete_forever</mat-icon>
                </button>
            </td>
        </ng-container>

        <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
        <tr mat-row *matRowDef="let row; columns: displayedColumns;"></tr>

    </table>
    <mat-paginator [pageSizeOptions]="[5, 10]" showFirstLastButtons></mat-paginator>
</div>